/**********************************************************************************/
/*                 How to Kill Your Server in 60 (75) Minutes                     */
/*                     Written by: Dmitri V. Korotkevitch                         */
/*                            dk@aboutsqlserver.com                               */
/*                          http://aboutsqlserver.com                             */
/**********************************************************************************/
/*                                   04.UDF                                       */
/**********************************************************************************/

set nocount on
go

use ForestSoft
go

/*  
alter function [fs].[IsCustomerActive](@LastActivityDate datetime)
returns bit
as
begin
	return
		case 
			when (@LastActivityDate >= dateadd(month,-3,GetDate()))
			then 1 
			else 0
		end
end
go
*/


select count(*)
from fs.Customers
where fs.IsCustomerActive(LastActivityDate) = 1








/*
alter function [fs].[IsCustomerActiveInline](@LastActivityDate datetime)
returns table
as
return
(
	select
		case 
			when (@LastActivityDate >= dateadd(month,-3,GetDate()))
			then 1 
			else 0
		end as [Active]
)
go
*/

set statistics io, time on

select count(*)
from fs.Customers
where fs.IsCustomerActive(LastActivityDate) = 1

select count(*)
from 
	fs.Customers c
		cross apply fs.IsCustomerActiveInline(c.LastActivityDate) a
where 
	a.Active = 1

set statistics io, time off
go
