/**********************************************************************************/
/*                 How to Kill Your Server in 60 (75) Minutes                     */
/*                     Written by: Dmitri V. Korotkevitch                         */
/*                            dk@aboutsqlserver.com                               */
/*                          http://aboutsqlserver.com                             */
/**********************************************************************************/
/*                                  04.Views                                      */
/**********************************************************************************/

set nocount on
go

use ForestSoft
go


if exists (select * from sys.foreign_keys where name = 'FK_Addresses_Customers') alter table fs.Addresses drop constraint FK_Addresses_Customers;
if exists (select * from sys.foreign_keys where name = 'FK_Customers_CustomerCategories') alter table fs.Customers drop constraint FK_Customers_CustomerCategories;
go

/*
alter view [fs].[vCustomers]
as
	select c.CustomerId, c.CustomerCategoryId, c.CustomerNumber, c.CustomerName
		, c.LastActivityDate, cc.CustomerCategoryName, a.AddressId
		,a.Address, a.Island
	from 
		fs.Customers c join fs.CustomerCategories cc on 
			c.CustomerCategoryId = cc.CustomerCategoryId
		join fs.Addresses a on
			c.CustomerId = a.CustomerId and 
			a.IsPrimary = 1

*/

-- Include "Enable Execution Plan"

select * from fs.vCustomers
select CustomerId, CustomerNumber from fs.vCustomers
go




/*
create view [fs].[vCustomers2]
as
	select c.CustomerId, c.CustomerCategoryId, c.CustomerNumber, c.CustomerName
		, c.LastActivityDate, cc.CustomerCategoryName, a.AddressId
		,a.Address, a.Island
	from 
		fs.Customers c left outer join fs.CustomerCategories cc on 
			c.CustomerCategoryId = cc.CustomerCategoryId
		left outer join fs.Addresses a on
			c.CustomerId = a.CustomerId and 
			a.IsPrimary = 1
*/
select * from fs.vCustomers2
select CustomerId, CustomerNumber from fs.vCustomers2
go





alter table fs.Customers 
with check
add constraint FK_Customers_CustomerCategories
foreign key(CustomerCategoryID)
references fs.CustomerCategories(CustomerCategoryID)
go

alter table fs.Addresses 
with check
add constraint FK_Addresses_Customers
foreign key(CustomerID)
references fs.Customers(CustomerID)
go

/*** ALWAYS ADD INDEXES ON REFERENCING COLUMNS ***/

select * from fs.vCustomers
select CustomerId, CustomerNumber from fs.vCustomers
go

if exists (select * from sys.foreign_keys where name = 'FK_Addresses_Customers') alter table fs.Addresses drop constraint FK_Addresses_Customers;
if exists (select * from sys.foreign_keys where name = 'FK_Customers_CustomerCategories') alter table fs.Customers drop constraint FK_Customers_CustomerCategories;
go