/**********************************************************************************/
/*                 How to Kill Your Server in 60 (75) Minutes                     */
/*                     Written by: Dmitri V. Korotkevitch                         */
/*                            dk@aboutsqlserver.com                               */
/*                          http://aboutsqlserver.com                             */
/**********************************************************************************/
/*                                   06.XML                                       */
/**********************************************************************************/

set noexec off
go

set nocount on
go

use ForestSoft
go

if exists
(
	select * 
	from 
		sys.schemas s join sys.tables t on
			s.schema_id = t.schema_id
		join sys.columns col on
			col.object_id = t.object_id
	where
		s.name = 'fs' and t.name = 'Products' and col.name = 'Attributes' 
)
begin
	raiserror('Column Products.Attributes has been already defined',16,1) 
	set noexec on
end
go

alter table fs.Products
add Attributes xml null
go

update t
set
	Attributes = (
		select 
			p.Weight as [Weight]
			,p.Color as [Color]
			,p.DaysToManufacture as DaysToManufacture
		from fs.Products p
		where p.ProductId = t.ProductId
		for xml path('Attributes')
	)
from 
	fs.Products t
go

alter index PK_Products on fs.Products rebuild
go

-- Enable "Include Actual Execuion Plan"
exec fs.[SearchProductsXML] @Name = 'F', @Number = null
go

